<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_product_typeVideotype extends JPlugin
{
	function plgJoomsuite_product_typeVideotype( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'uploader.php';

		$this->helper = & JS_Res_FancyUploaderHelper::getInstance();

		$path = JPATH_PLUGINS.DS.'joomsuite_product_type'.DS.'html'.DS.'jspt_res_file_manager.php';
		if (JFile::exists($path))
		require_once $path;
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'videotype') return;
		$index = 'file-'.$obj->id;
		$sess = &JFactory::getSession();

		$optExts = $params->get('allowed_formats');
		$optExts = 'swf, avi, wmv, mpeg, mov';
		$out = '';

		if(isset($obj->$index) && $obj->$index != '')
		{
			$files = $obj->$index;
			settype($files, 'array');
		}
		else
		$files = array();

		$db = & JFactory::getDBO();
		$sql = 'SELECT user_id FROM #__js_res_record WHERE id = '.$obj->record_id;
		$db->setQuery($sql);
		$obj->user_id = $db->loadResult();

		$recordId 	= JHTMLJsmedia_new::getRealRecordId($obj, $type);
		$url 		= JHTMLJsmedia_new::getUploadUrl($obj, $type, $recordId);
		$debug 		= false;
		$uid 		= uniqid('media_');
		$out .= JText::_('Allowed formats are ').": $optExts<br>";
		switch($params->get('type'))
		{
			case 1:
				$options = array(
				'files' => $files,
			 	'title' => 'Upload your file',
				'url' => $url,			 
				'limitSize' => $params->get('max') ? ((int)$params->get('max')) * 1024 : 'false',
				'maxFiles' => 1,
				'debug' => $debug, // optional
				'backgroundColor' => '#FFFFFF',
				'filters' => explode(", ", $optExts),
				'uid' => $uid,
				'fieldId' => $obj->id,
				'recordId' => $recordId,
				'processResponse' => false,
				'limitFiles' => 1// the number of files in uploader
				);
					
				$out.=  JHTMLJsmedia_new::getUploaderWithFilesTable($obj, $options);
				//$out .= "<input style=\"width:".$params->get('field_size')."\" type=\"file\" name=\"files[{$obj->id}]\" />";
				break;

			case 2:
				$out .= '<input type="text" style="width:'.$params->get('field_size').'" name="pparams['.$obj->id.'][file-'.$obj->id.']" value="'.(isset($obj->$index) ? $obj->$index : '').'" />';
				$out .= '<br>'.JText::_('Insert path based on joomla root.');
				break;
			case 3:
				$filter =  explode(", ", $optExts);
				$out .= '<select style="width:'.$params->get('field_size').'" name="pparams['.$obj->id.'][file-'.$obj->id.']" class="inputbox" size="1">';
				$out .= implode("\n", ResViewRecord::files($params->get('directory')/*.DS.'product_type'.DS.$obj->user_id*/, $params, (isset($obj->$index) ? $obj->$index : ''), $filter));
				$out .= '</select>';
				break;
		}
		if(isset($obj->$index) && $obj->$index && ($params->get('type') == 1) ){
			/*$out .= '<br><input type="checkbox" value="1" name="remove['.$obj->id.']" value="'.$obj->$index.'" />'.JText::_('Remove Current');
			 $out .= " ({$obj->$index})";*/
			$out .= "<input type=\"hidden\" name=\"pparams[".$obj->id."][file-{$obj->id}]\" value=\"{$obj->$index}\" />";
		}

		$out .= '<input type="hidden" name="fields[author]['.$obj->id.']" value="'.$obj->user_id.'">';
		$out .= '<input type="hidden" name="fields['.$obj->id.'][downloadable]" value="1">';
		echo $out;
	}

	function onBeforeSave(&$value, &$params, $type, $field_id, $row, &$error)
	{
		if($type != 'videotype') return;
		$sess = &JFactory::getSession();

		$db     = &JFactory::getDBO();

		$optExts = 'swf, avi, wmv, mpeg, mov';
		$exts = explode(", ", $optExts);
		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
		ResControllerConfig::initialyze();

		$user = JFactory::getUser();

		$fileManager = & JSPT_Res_File_Manager::getInstance();

		$fields = JRequest::getVar('fields');

		$files = $fields[$field_id]['files'];

		// Check, if the article was newly created
		$shamaned_prefix = JFile::makeSafe($sess->get('new_article_prefix', $row->id, $type));
		$newlyCreated = ($shamaned_prefix != $row->id);

		$shamaned_prefix .= '_';

		$path = JPATH_ROOT.DS.$params->get('directory').DS.'product_type';

		// track author change
		$auth = $_POST['fields']['author'][$field_id];
		$suffix = '';
		if($params->get('attach')) $suffix = $params->get('suffix');//'_'.time();

		$author = isset($auth) ? $auth : 0;
		if ($author != $row->user_id)
		$fileManager->reassignFiles($files, $row->id, $author, $row->user_id, $path, $suffix);
			
		//--------------------------------------------------------------------------

		$f = $files[0];
		$f = basename( $f );
		$ext = JString::strtolower(JFile::getExt( $f ));

		if (!in_array($ext, $exts)) {
			$error = true;
			JError::raiseWarning(JText::_('Extension is not allowed').' : '.$ext);
			return;
		}

		$f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);


		if($params->get('type') == 1)
		{
			$ptypes = JRequest::getVar('pparams');
			$old = $ptypes[$field_id]['file-'.$field_id];
			if($old && (!count($files) || $files[0] != $old) )
			{
				$file = JPATH_ROOT.DS.$params->get('directory').DS.'product_type'.DS.$row->user_id.DS.$old;
				if(file_exists($file))
				JFile::delete($file);
			}
		}
			
		$res = $fileManager->storeFile($shamaned_prefix.$f, $f, $row->user_id, $path.DS.$row->user_id, true, $suffix);
		$f = JFile::makeSafe(JFile::stripExt( $f ).$suffix.'.'.$ext);

		$sess->clear('new_article_prefix', $type);
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;
		
		if($type != 'videotype') return;
		if(!$field) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		
		$value = explode("=", $field->value);
		if(!isset($value[1]) || $value[1] == '' || $value[1] == -1) return;

		$db = & JFactory::getDBO();
		$uri = JFactory::getURI();
		$me = JFactory::getUser();
		$out = '';
		$sql = "SELECT id FROM #__js_res_record_values WHERE field_id = '{$field->field_id}' AND record_id = '{$field->record_id}'";
		$db->setQuery($sql);
		$file_id = $db->loadResult();

		$hits = $this->jsGetHits($file_id);

		$load = false;
		$buyer = false;
		if($me->id)
		{
			$sql = "SELECT COUNT(*) FROM #__jc_orders ord
			JOIN #__jc_orders_products pr ON ord.id = pr.order_id
			WHERE product_id = '{$field->record_id}' AND ord.user_id = '{$me->id}'
			AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
			$db->setQuery($sql);
			if($res = $db->loadResult())
			$buyer = $me->id;
		}
		else
		{
			$sql = "SELECT ord. email FROM #__jc_orders ord
			JOIN #__jc_orders_products pr ON ord.id = pr.order_id
			WHERE product_id = '{$field->record_id}' AND ord.user_id = 0
			AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
			$db->setQuery($sql);
			if($order_emails = $db->loadResultArray())
			{
				$session = JFactory::getSession();
				if($customer = $session->get('customer'))
				{
					if(in_array($customer['cemail'], $order_emails))
					{
						$buyer = $customer['cemail'];
					}
				}
			}
		}

		if($buyer)
		{
			$load = true;
		}

		$path = JPATH_ROOT.DS.$params->get('directory');
		$newfile = 'thumb_'.$value[1];
		switch ($params->get('type'))
		{
			case 1:
				$file   = $path.DS.'product_type'.DS.$field->user_id.DS.$value[1];
				$newfile = $path.DS.'product_type'.DS.$field->user_id.DS.$newfile;
				break;
			case 3:
			case 2:
				$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
				$newfile = JPath::clean(JPATH_ROOT.DS.$newfile);
				break;
		}

		$rec_value_id = $this->getRecordValueId($db, $field->field_id, $field->record_id);

		if($load)
		{
			$sql = "SELECT ex.value, ex.ref_id, ex.record_id, ex.user_id, ex.field_id
			FROM #__jc_orders_products pr
			JOIN #__jc_orders ord ON pr.order_id = ord.id
			JOIN #__jc_orders_statuses os ON os.id = pr.status_id
			JOIN #__js_res_field_extra ex ON pr.product_id=ex.record_id
			WHERE ex.field_id = '{$field->field_id}'
			AND ex.record_id = '".(JRequest::getInt('download') && JRequest::getInt('record_id') ? JRequest::getInt('record_id') : $field->record_id)."'
			AND ord.user_id = '".$me->id."' AND os.isfinal = '1'";
			$db->setQuery($sql);
			if($res = $db->loadObject())
			{
				$path = JPATH_ROOT.DS.$params->get('directory');
				switch ($params->get('type'))
				{
					case 1:
						$file   = $path.DS.'product_type'.DS.$res->user_id.DS.$value[1];
						break;
					case 3:
					case 2:
						$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
						break;
				}
				$val = explode("-", $value[0]);

				if(JRequest::getInt('download') && JRequest::getInt('field') && JRequest::getInt('field') == $val[1])// && (!$params->get('unique') || ($params->get('unique') && $hits < 1) ))
				{

					$user = & JFactory::getUser();
					$id = JRequest::getInt('field');

					$db = & JFactory::getDBO();

					$browser =  $_SERVER['HTTP_USER_AGENT'];

					if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OPERA';
					} else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'IE';
					} else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OMNIWEB';
					} else if(ereg('(Konqueror/)(.*)', $browser)) {
						$browser =  'KONQUEROR';
					} else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'MOZILLA';
					} else {
						$browser =  'OTHER';
					}

					if(!$res)
					{
						JError::raiseError(500, JText::_('Item Not found'));
					}
					$fvalue = explode("=", $res->value);

					if(isset($fvalue[1]) && $fvalue[1] != '' )
					{
						if($params->get('type', 1) == 1)
						{
							$file = $path.DS.'product_type'.DS.$res->user_id;
							$file .= DS.$fvalue[1];
						}
						else
						{
							$file = JPath::clean(JPATH_ROOT.DS.$fvalue[1]);
						}
						$ext = strtolower(substr($fvalue[1], strrpos($fvalue[1], '.') + 1) );


						switch ($ext)
						{
							case "swf":
								$type = 'application/x-shockwave-flash';
								break;
							case "avi":
								$type = 'video/x-msvideo ';
								break;
							case "mov":
								$type = 'video/quicktime';
								break;
							case "wmv":
								$type = 'application/x-oleobject';
								break;
							case "mpeg":
							case "mpg":
							case "mpe":
								$type = 'video/mpeg';
								//$type = 'application/x-oleobject';
						}
						if(file_exists($file))
						{
							header("Content-Type: $type");
							header("Content-Length: " . filesize($file));
							if($params->get('cache'))
							{
								header('Expires: '.date('D, d M Y H:i:s', time() + 86400).' GMT');
								header('Pragma: private');
							}
							$this->readfile_chunked($file);

							exit;
						}
					}
				}

				$value = explode("=", $field->value);
				$val = explode("-", $value[0]);

				switch ($params->get('type'))
				{
					case 1:
						$file   = $path.DS.'product_type'.DS.$res->user_id.DS.$value[1];
						break;
					case 3:
					case 2:
						$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
						break;
				}
				//$file   = $path.DS.'product_type'.DS.$res->user_id.DS.$value[1];

				if(file_exists($file))
				{

					$uri->setVar('download', '1');
					$uri->setVar('record_id', $res->record_id);
					$uri->setVar('field', $val[1]);
					$download = $uri->toString();
					$uri->delVar('download');
					$uri->delVar('record_id');
					$uri->delVar('field');

					$source = $download;

					$ext = strtolower(substr($value[1], strrpos($value[1], '.') + 1 ) );
					$quality = $params->get('quality');
					$bg = $params->get('background');
					$width = $params->get('width');
					$height = $params->get('height');

					$embede="";
					switch ($ext)
					{
						case "swf":
							$embede = "
							<object classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\""
							.(isset($width) ? " width=\"$width\" " : NULL)
							.(isset($height) ? " height=\"$height\" " : NULL)
							."><param name=\"movie\" value=\"$source\" />
							<param name=\"quality\" value=\"$quality\" />
							<param name=\"bgcolor\" value=\"$bg\" />
							<embed src=\"$source\" quality=\"$quality\" bgcolor=\"$bg\""
							.(isset($width) ? " width=\"$width\" " : NULL)
							.(isset($height) ? " height=\"$height\" " : NULL)
							."name=\"movie$field->id\" align=\"\" type=\"application/x-shockwave-flash\"
							pluginspage=\"http://www.macromedia.com/go/getflashplayer\">
							</embed>
							</object>";
							break;

						case "avi":
						case "wmv":
							$embede = "
							<OBJECT id=\"movie$field->id\" width=\"$width\" height=\"$height\"
							CLASSID=\"CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6\"
							type=\"application/x-oleobject\">

							<PARAM NAME=\"URL\" VALUE=\"$source\">
							<PARAM NAME=\"SendPlayStateChangeEvents\" VALUE=\"True\">
							<PARAM NAME=\"AutoStart\" VALUE=\"False\">
							<PARAM name=\"uiMode\" value=\"mini\">
							<PARAM name=\"PlayCount\" value=\"1\">
							<embed src=\"$source\" AutoStart=\"False\" PlayCount=\"1\" uiMode=\"mini\"></embed>
							</OBJECT>";
							break;
						case "mpeg":
						case "mpg":

							$embede ="
							<object CLASSID=\"CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95\"
							codebase=\"http://activex.microsoft.com/activex/controls/mplayer/en/nsm p2inf.cab#Version=5,1,52,701\"
							standby=\"Loading Microsoft Windows� Media Player components...\"
							type=\"application/x-oleobject\" width=\"$width\" height=\"$height\">
							<param name=\"fileName\" value=\"$source\">
							<param name=\"animationatStart\" value=\"true\">
							<param name=\"transparentatStart\" value=\"true\">
							<param name=\"autoStart\" value=\"false\">
							<param name=\"showControls\" value=\"true\">
							<embed id=\"movie$field->id\" type=\"application/x-mplayer2\"
							pluginspage=\"http://www.microsoft.com/Windows/MediaPlayer/\"
							src=\"$source\" name=\"MediaPlayer1\" width=$width height=$height autostart=1 showcontrols=1>
							</object>";

							break;
						case "mov":
							$embede ="<object width=\"$width\" height=\"$height\"  id=\"movie$field->id\"
							classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\"
							codebase=\"http://www.apple.com/qtactivex/qtplugin.cab\">
							<param name=\"src\" value=\"$source\">
							<param name=\"controller\" value=\"true\">
							<param name=\"autoplay\" value=\"false\">
							<!-- Code For Older Browsers -->
							<embed src=\"$source\" width=\"$width\" height=\"$height\"
							autoplay=\"false\"
							controller=\"true\"
							pluginspage=\"http://www.apple.com/quicktime/download/\">
							</embed>
							</object>";
							break;
					}

					$out = $embede;

					$addition = array();

					if($params->get('show_size'))
					{
						$addition[] = JText::_('Size').': '.$this->jsFormatSize(filesize($file));
					}
					/*if($params->get('show_hits', 1))
					{
						$addition[] = JText::_('Hits').': '.$this->jsGetHits($file_id);
					}*/
					if($params->get('show_ctime'))
					{
						$addition[] = JText::_('Create Time').': '.strftime(JText::_('%d %b %Y'), filectime($file));
					}
					if(count($addition) > 0) $out .= '<br><span class="small js_small">('.implode(" | ", $addition).')</span> ';


				}
			}
			else
			$out = JText::_("To get video you need to purchase this product");

		}
		else
		{
			$out = JText::_("To get video you need to purchase this product");

		}

	}

	function onOrderHistoryPrint($type, $order_id, $product_id, $value, $final_status, $user_id, $params)
	{
		if($type != 'videotype') return;

		if($value == '') return;
		$out = '';

		$params = new JParameter($params);

		$db = & JFactory::getDBO();
		$out = '';

		$db = & Jfactory::getDBO();
		$path = JPATH_ROOT.DS.$params->get('directory');

		$value = explode("=", $value);
		$val = explode("-", $value[0]);
		if(isset($val[1]) && $val[1] != '' && $value[1] != '-1')
		{
			$sql = "SELECT id FROM #__js_res_record_values WHERE field_id = '$val[1]' AND record_id = '$product_id'";
			$db->setQuery($sql);
			$file_id = $db->loadResult();
			$hits = $this->jsGetHits($file_id);

			$me = JFactory::getUser();

			$load = false;
			$buyer = false;
			if($me->id)
			{
				if($final_status)
				$buyer = $me->id;
			}
			else
			{
				$sql = "SELECT ord. email FROM #__jc_orders ord
				JOIN #__jc_orders_products pr ON ord.id = pr.order_id
				WHERE product_id = '{$product_id}' AND ord.user_id = 0
				AND pr.status_id = (SELECT id FROM #__jc_orders_statuses WHERE isfinal = '1' AND published = '1' AND  type= 'product')";
				$db->setQuery($sql);
				if($order_emails = $db->loadResultArray())
				{
					$session = JFactory::getSession();
					if($customer = $session->get('customer'))
					{
						if(in_array($customer['cemail'], $order_emails))
						{
							$buyer = $customer['cemail'];
						}
					}
				}
			}

			if($buyer)
			{
				$load = true;
			}



			if($load)
			{
				$path = JPATH_ROOT.DS.$params->get('directory');
				$sql = "SELECT user_id FROM #__js_res_record WHERE id = '$product_id'";
				$db->setQuery($sql);
				$author = $db->loadResult();

				if(JRequest::getInt('download') && JRequest::getInt('field') && JRequest::getInt('field') == $val[1])
				{
					$id = JRequest::getInt('field');

					$user = & JFactory::getUser();

					$browser =  $_SERVER['HTTP_USER_AGENT'];


					if(ereg('Opera(/| )([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OPERA';
					} else if(ereg('MSIE ([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'IE';
					} else if(ereg('OmniWeb/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'OMNIWEB';
					} else if(ereg('(Konqueror/)(.*)', $browser)) {
						$browser =  'KONQUEROR';
					} else if(ereg('Mozilla/([0-9].[0-9]{1,2})', $browser)) {
						$browser =  'MOZILLA';
					} else {
						$browser =  'OTHER';
					}


					if(isset($value[1]) && $value[1] != '' )
					{
						if($params->get('type', 1) == 1)
						{
							$file = $path.DS.'product_type'.DS.$author;
							$file .= DS.$value[1];
						}
						else
						{
							$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
						}
						$ext = strtolower(substr($value[1], strrpos($value[1], '.') + 1) );


						switch ($ext)
						{
							case "swf":
								$type = 'application/x-shockwave-flash';
								break;
							case "avi":
								$type = 'video/x-msvideo ';
								break;
							case "mov":
								$type = 'video/quicktime';
								break;
							case "wmv":
								$type = 'application/x-oleobject';
								break;
							case "mpeg":
							case "mpg":
							case "mpe":
								$type = 'video/mpeg';
								//$type = 'application/x-oleobject';
						}


						if(file_exists($file))
						{
							/*$this->hit($file_id);
							 header('Content-Type: '.(($browser=='IE' || $browser=='OPERA') ? 'application/octetstream':'application/octet-stream'));
							 header('Expires: '.gmdate('D, d M Y H:i:s').' GMT');
							 header('Content-Transfer-Encoding: binary');
							 header('Content-Length: '.filesize($file));
							 header("Content-Encoding: none");
							 if($browser=='IE') {
								header('Content-Disposition: attachment; filename="'.basename($value[1]).'"');
								header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
								header('Pragma: public');
								} else {
								header('Content-Disposition: attachment; filename="'.basename($value[1]).'"');
								header('Cache-Control: no-cache, must-revalidate');
								header('Pragma: no-cache');
								}*/
							header("Content-Type: $type");
							header("Content-Length: " . filesize($file));
							if($params->get('cache'))
							{
								header('Expires: '.date('D, d M Y H:i:s', time() + 86400).' GMT');
								header('Pragma: private');
							}
							$this->readfile_chunked($file);
							exit;
						}
					}
				}

				switch ($params->get('type'))
				{
					case 1:
						$file   = $path.DS.'product_type'.DS.$author.DS.$value[1];
						break;
					case 3:
					case 2:
						$file = JPath::clean(JPATH_ROOT.DS.$value[1]);
						break;
				}

				if(file_exists($file))
				{
					$uri = JFactory::getURI();
					$uri->setVar('download', '1');
					$uri->setVar('record_id', $product_id);
					$uri->setVar('field', $val[1]);
					$download = $uri->toString();
					$uri->delVar('download');
					$uri->delVar('record_id');
					$uri->delVar('field');

					if($params->get('show_name'))
					{
						$label = basename($value[1]);
					}
					else {
						$label = JText::_("Download video");
					}

					$link = JHTML::link($download, $label);

					$source = $download;

					$ext = strtolower(substr($value[1], strrpos($value[1], '.') + 1 ) );
					$quality = $params->get('quality');
					$bg = $params->get('background');
					$width = $params->get('width');
					$height = $params->get('height');

					$embede="";
					switch ($ext)
					{
						case "swf":
							$embede = "
							<object classid=\"clsid:d27cdb6e-ae6d-11cf-96b8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\""
							.(isset($width) ? " width=\"$width\" " : NULL)
							.(isset($height) ? " height=\"$height\" " : NULL)
							."><param name=\"movie\" value=\"$source\" />
							<param name=\"quality\" value=\"$quality\" />
							<param name=\"bgcolor\" value=\"$bg\" />
							<embed src=\"$source\" quality=\"$quality\" bgcolor=\"$bg\""
							.(isset($width) ? " width=\"$width\" " : NULL)
							.(isset($height) ? " height=\"$height\" " : NULL)
							."name=\"movie".$val[1]."\" align=\"\" type=\"application/x-shockwave-flash\"
							pluginspage=\"http://www.macromedia.com/go/getflashplayer\">
							</embed>
							</object>";
							break;

						case "avi":
						case "wmv":
							$embede = "
							<OBJECT id=\"movie$field->id\" width=\"$width\" height=\"$height\"
							CLASSID=\"CLSID:6BF52A52-394A-11d3-B153-00C04F79FAA6\"
							type=\"application/x-oleobject\">

							<PARAM NAME=\"URL\" VALUE=\"$source\">
							<PARAM NAME=\"SendPlayStateChangeEvents\" VALUE=\"True\">
							<PARAM NAME=\"AutoStart\" VALUE=\"False\">
							<PARAM name=\"uiMode\" value=\"mini\">
							<PARAM name=\"PlayCount\" value=\"1\">
							<embed src=\"$source\" AutoStart=\"False\" PlayCount=\"1\" uiMode=\"mini\"></embed>
							</OBJECT>";
							break;
						case "mpeg":
						case "mpg":

							$embede ="
							<object CLASSID=\"CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95\"
							codebase=\"http://activex.microsoft.com/activex/controls/mplayer/en/nsm p2inf.cab#Version=5,1,52,701\"
							standby=\"Loading Microsoft Windows� Media Player components...\"
							type=\"application/x-oleobject\" width=\"$width\" height=\"$height\">
							<param name=\"fileName\" value=\"$source\">
							<param name=\"animationatStart\" value=\"true\">
							<param name=\"transparentatStart\" value=\"true\">
							<param name=\"autoStart\" value=\"false\">
							<param name=\"showControls\" value=\"true\">
							<embed id=\"movie".$val[1]."\" type=\"application/x-mplayer2\"
							pluginspage=\"http://www.microsoft.com/Windows/MediaPlayer/\"
							src=\"$source\" name=\"MediaPlayer1\" width=$width height=$height autostart=1 showcontrols=1>
							</object>";

							break;
						case "mov":
							$embede ="<object width=\"$width\" height=\"$height\"  id=\"movie$field->id\"
							classid=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\"
							codebase=\"http://www.apple.com/qtactivex/qtplugin.cab\">
							<param name=\"src\" value=\"$source\">
							<param name=\"controller\" value=\"true\">
							<param name=\"autoplay\" value=\"false\">
							<!-- Code For Older Browsers -->
							<embed src=\"$source\" width=\"$width\" height=\"$height\"
							autoplay=\"false\"
							controller=\"true\"
							pluginspage=\"http://www.apple.com/quicktime/download/\">
							</embed>
							</object>";
							break;
					}

					$out = $embede;

					$addition = array();

					if($params->get('show_size'))
					{
						$addition[] = JText::_('Size').': '.$this->jsFormatSize(filesize($file));
					}
					/*if($params->get('show_hits', 1))
					{
						$addition[] = JText::_('Hits').': '.$this->jsGetHits($file_id);
					}*/
					if($params->get('show_ctime'))
					{
						$addition[] = JText::_('Create Time').': '.strftime(JText::_('%d %b %Y'), filectime($file));
					}
					if(count($addition) > 0) $out .= '<br><span class="small js_small">('.implode(" | ", $addition).')</span> ';
				}
			}
		}

		return $out;
	}

	function onTypeFormRender()
	{

	}

	function onBeforeCartStore()
	{

	}


	function jsFormatSize($size)
	{

		$kb = 1024;
		$mgb = $kb * 1024;
		$gb  = $mgb * 1024;
		$trb = $gb * 1024;

		if($size > $trb)
		{
			return number_format($size / $trb, 2, ',', ' ')." Tb";
		}
		elseif($size > $gb)
		{
			return number_format($size / $gb, 1, ',', ' ')." Gb";
		}
		elseif($size > $mgb)
		{
			return number_format($size / $mgb, 0, ',', ' ')." Mb";
		}
		elseif($size > $kb)
		{
			return number_format($size / $kb, 0, ',', ' ')." Kb";
		}
		else
		{
			return $size." B";
		}
	}
	function jsGetHits($id)
	{
		$db = &JFactory::getDBO();

		$sql = "SELECT COUNT(*) FROM #__js_res_download_hits WHERE item_id = '{$id}'";
		$db->setQuery($sql);
		return intval($db->loadResult());
	}
	function hit($id)
	{
		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$uid = $user->get('id');

		$sql = "INSERT INTO #__js_res_download_hits VALUES(NULL, '{$uid}', '{$id}', NOW(), '".$_SERVER['REMOTE_ADDR']."')";
		$db->setQuery($sql);
		$db->query();
	}

	function readfile_chunked($filename,$retbytes=true) {
		error_reporting(0);
		//ignore_user_abort(true);
		set_time_limit(0);
		$chunksize = 1*(1024*1024); // how many bytes per chunk
		$buffer = '';
		$cnt =0;
		// $handle = fopen($filename, 'rb');
		$handle = fopen($filename, 'rb');
		if ($handle === false) {
			echo "Cannot open file"; exit;
			return false;
		}
		while (!feof($handle)) {
			$buffer = @fread($handle, $chunksize);
			echo $buffer;
			if ($retbytes) {
				$cnt += strlen($buffer);
			}
		}
		$status = fclose($handle);
		if ($retbytes && $status) {
			return $cnt; // return num. bytes delivered like readfile() does.
		}
		return $status;
	}

	function getRecordValueId($db, $field_id, $record_id)
	{
		$sql = "SELECT id FROM #__js_res_record_values WHERE field_id = '$field_id' AND record_id = '$record_id'";
		$db->setQuery($sql);
		return $db->loadResult();
	}
}
?>